//+------------------------------------------------------------------+
//|                                               IndexSort_Test.mq5 |
//|                                       Copyright 2012, MetaDriver |
//|                                            MetaDriver@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaDriver"
#property link      "MetaDriver@rambler.ru"
#property version   "1.00"
#property script_show_inputs

#include <Indexes\\IndexSort.mqh>
//--- input parameters
input int      ASize=16;

double darray[];
int    iarray[];
int    index[];
string SArray[] = {
  "", "", "MetaQuotes", "", "", "", "",""};
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
    ArrayResize(darray,ASize);
    for(int i=0;i<ASize;i++)
      {
       darray[i] = rand() / 333.3333;
      }
    
    string S="{";
    for(int i=0;i<ASize;i++)
      {
       S=S+DoubleToString(darray[i],2) + ((i+1<ASize)?", ":"}");
      }
    Print("darray[i]            = ",S);
 
    ArrayIndexSort(darray,index,true);

    S="{";
    for(int i=0;i<ASize;i++)
      {
       S=S+DoubleToString(darray[index[i]],2) + ((i+1<ASize)?", ":"}");
      }
    Print("darray[index[i]] = ",S);

    ArrayIndexSort(darray,index,false);

    S="{";
    for(int i=0;i<ASize;i++)
      {
       S=S+DoubleToString(darray[index[i]],2) + ((i+1<ASize)?", ":"}");
      }
    Print("darray[index[i]] = ",S);

    ArrayResize(iarray,ASize);
    for(int i=0;i<ASize;i++)
      {
       iarray[i] = rand() % 10000;
      }
    
    S="{";
    for(int i=0;i<ASize;i++)
      {
       S=S+IntegerToString(iarray[i]) + ((i+1<ASize)?", ":"}");
      }
    Print("iarray[i]            = ",S);
 
    ArrayIndexSort(iarray,index,true);

    S="{";
    for(int i=0;i<ASize;i++)
      {
       S=S+IntegerToString(iarray[index[i]]) + ((i+1<ASize)?", ":"}");
      }
    Print("iarray[index[i]] = ",S);

    ArrayIndexSort(iarray,index,false);

    S="{";
    for(int i=0;i<ASize;i++)
      {
       S=S+IntegerToString(iarray[index[i]]) + ((i+1<ASize)?", ":"}");
      }
    Print("iarray[index[i]] = ",S);
//--   
    S="{";
    for(int i=0;i<ArraySize(SArray);i++)
      {
       S=S+(SArray[i]) + ((i+1<ArraySize(SArray))?", ":"}");
      }
    Print("SArray[i]            = ",S);
 
    ArrayIndexSort(SArray,index,true);

    S="{";
    for(int i=0;i<ArraySize(SArray);i++)
      {
       S=S+(SArray[index[i]]) + ((i+1<ArraySize(SArray))?", ":"}");
      }
    Print("SArray[index[i]] = ",S);

    ArrayIndexSort(SArray,index,false);

    S="{";
    for(int i=0;i<ArraySize(SArray);i++)
      {
       S=S+(SArray[index[i]]) + ((i+1<ArraySize(SArray))?", ":"}");
      }
    Print("SArray[index[i]] = ",S);


  }
//+------------------------------------------------------------------+
